#!/bin/bash
echo "======================================================================"
echo "= This script will root your Android phone with adb restore function ="
echo "= Script by Bin4ry (thanks to Goroh_kun and tkymgr for the idea)     ="
echo "=                         (14.09.2012)                               ="
echo "=                          ported to Linux by Kamistral (15.09.2012) ="
echo "======================================================================"
echo
echo "Device type:"
echo "1) Xperia T"
echo "2) LT26,LT22 etc."
echo "3) Other"
echo "Make a choice: "
read type
case $type in
 1*) echo "Xperia T mode enabled!" ;;
 2*) echo "LT26,LT22 etc. mode enabled!" ;;
 3*) echo "Normal Mode enabled!" ;;
 *)  echo "Please start again and enter a valid number (1 or 3)"
     exit ;;
esac
echo "Please connect device with ADB-Debugging enabled now...."
./stuff/adb wait-for-device
./stuff/adb push stuff/busybox /data/local/tmp/.
./stuff/adb push stuff/su /data/local/tmp/.
./stuff/adb push stuff/Superuser.apk /data/local/tmp/.
./stuff/adb shell chmod 755 /data/local/tmp/busybox
if [ "$type" = "2" ]
  then
    ./stuff/adb push stuff/RootMe.tar /data/local/tmp/RootMe.tar
    ./stuff/adb shell "mkdir /mnt/sdcard/.semc-fullbackup > /dev/null 2>&1"
    ./stuff/adb shell "cd /mnt/sdcard/.semc-fullbackup/; /data/local/tmp/busybox tar xf /data/local/tmp/RootMe.tar"
    echo "Please take your device, open Backup and Restore App from Menu. Select the backup named RootMe and restore it!"
    echo "If all is successful i will tell you, if not this shell will run forever."
    ./stuff/adb shell "while ! ln -s /data/local.prop /data/data/com.android.settings/a/file99; do :; done" >/dev/null
    echo
    echo "Good, it worked! Now we are rebooting soon, please be patient!"
    ./stuff/adb reboot
    ping -c3 127.0.0.1 > /dev/null
    echo Waiting for device to come up again....
    ./stuff/adb wait-for-device
  else
    ./stuff/adb restore stuff/fakebackup.ab
    echo "Please look at your device and click RESTORE!"
    echo "If all is successful i will tell you, if not this shell will run forever."
    ./stuff/adb shell "while ! ln -s /data/local.prop /data/data/com.android.settings/a/file99; do :; done" >/dev/null
    echo "Successful, going to reboot your device!"
    ./stuff/adb reboot
    echo "Waiting for device to show up again...."
    ping -c3 127.0.0.1 > /dev/null 
    ./stuff/adb wait-for-device
fi
if [ "$type" = "1" ]
  then
    echo
    echo The Xperia T will reboot 2 times! This is normal please be patient!
    ./stuff/adb wait-for-device
    ./stuff/adb remount
    ./stuff/adb shell "dd if=/data/local/tmp/su of=/system/bin/su"
    ./stuff/adb shell "chmod 06755 /system/bin/su"
    ./stuff/adb shell "sync; sync; sync;"
    ping -c3 127.0.0.1 > /dev/null
    ./stuff/adb remount
    ./stuff/adb shell "dd if=/data/local/tmp/Superuser.apk of=/system/app/Superuser.apk"
    ./stuff/adb shell "chmod 644 /system/app/Superuser.apk"
    ./stuff/adb shell "sync; sync; sync;"
    ping -c3 127.0.0.1 > /dev/null
    ./stuff/adb shell "rm /data/local.prop"
    ./stuff/adb shell "sync; sync; sync;"
  else
    ./stuff/adb shell "/data/local/tmp/busybox mount -o remount,rw /system"
    ./stuff/adb shell "dd if=/data/local/tmp/su of=/system/xbin/su"
    ./stuff/adb shell "chmod 06755 /system/xbin/su"
    ./stuff/adb shell "dd if=/data/local/tmp/Superuser.apk of=/system/app/Superuser.apk"
    ./stuff/adb shell "chmod 655 /system/app/Superuser.apk"
    ./stuff/adb shell "rm /data/local.prop"
    ./stuff/adb shell "sync; sync; sync;"
    ./stuff/adb reboot
fi
echo "You can close all open command-prompts now!"
echo "After reboot all is done! Have fun with Root!"
echo "Bin4ry"
read -p "Press [Enter] key to quit..."
